/*
NOMBRE:      ppw
SINTAXIS:    ppw <puerto local> <IP proxy> <puerto proxy>

*/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>

#define BUFSIZE 4096
#define MAXHOSTNAME 80


void reusePort(int sock);  //rutina para reusar un puerto
int ntotbytes=0;
int ntotconec=0;
int nRetbytes=0;
int nRetconec=0;

main( argc, argv )
int argc;
char *argv[];
{
  int   s, ss, pd;
  struct   sockaddr_in server;
  struct sockaddr_in from;
  struct sockaddr_in proxy;
  struct  hostent *tproxy , *gethostbyname();
  int fromlen;
  int length;
  char inbuf[BUFSIZE];

  fd_set readfds, readfdsCopy, readProxy;
  int n,i,cc;
  int sockList[64], lastSock=0;
  int sockProxy[64], lastProxy=0;


  if (argc != 4)
      {
      printf("Error en argumentos! \n");
      printf("Sintaxis: ppw <puerto_local> <IP_proxy> <puerto_proxy> \n");
      exit(-1);
      }


 /* Obtencin de datos del Proxy: nombre, familia y puerto */

  tproxy = gethostbyname(argv[2]);
  bcopy ( tproxy->h_addr, &(proxy.sin_addr), tproxy->h_length);
  proxy.sin_family = tproxy->h_addrtype;
  proxy.sin_port = htons(atoi(argv[3]));


  /* Socket para este servidor (ppw).  El puerto es ingresado por consola. */

  server.sin_family = AF_INET;
  server.sin_addr.s_addr = htonl(INADDR_ANY);
  server.sin_port = htons(atoi(argv[1]));

  s = socket (AF_INET,SOCK_STREAM,0);
  reusePort(s);

  /* Se realiza el bind correspondiente para asociar el socket al servidor */
  if ( bind( s, (struct sockaddr *)&server, sizeof(server) ) ) {
    close(s);
    perror("binding name to stream socket");
    exit(-1);
  }

  printf("Servidor de pesaje: ARAGORN  \n");
  printf("Puerto: %d\n\n", ntohs(server.sin_port));
  printf("Proxy: %s \n", argv[2]);
  printf("Puerto: %d\n\n", ntohs(proxy.sin_port));
  printf("*** PRESIONE ENTER PARA OBTENER ESTADSTICAS *** \n\n");

  /* Escuchando por nuevas conexiones de clientes, hasta un mximo de 5 en cola*/
  listen(s,5);

  /* Se obtiene el largo de estructura de clientes (from). Este dato ser usado
     luego cuando se acepten conexiones provenientes de clientes */
  fromlen = sizeof(from);


  /* readfdsCopy contendr los descriptores que se desea monitorear con select
     Primero se limpia (FD_ZERO), y luego se agrega s (clientes) y la entrada estndar (0) */

  FD_ZERO(&readfdsCopy);
  FD_SET(s,&readfdsCopy);
  FD_SET(0,&readfdsCopy);


  for(;;)
    {
    /* Con memcpy se copian los descriptores contenidos en readfdsCopy a readfds
       Las modificaciones se realizarn sobre readfdsCopy, pero se verifica si hay
       actividad sobre readfds.
       A continuacin se invoca a la funcin select, activndola con la opcin que
       permite conocer cundo se produce lectura en alguno de los descriptores conteidos
       en readfds */

    memcpy(&readfds, &readfdsCopy, sizeof(fd_set));
    n = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL);

    if (n > 0)
    {
      	if (FD_ISSET(s, &readfds))      //Hubo actividad?
	{
		/*Se realiza un accept para cada nueva conexin */
		//printf("Nueva conexin...\n");
		sockList[lastSock++] = accept(s, (struct sockaddr *)&from, &fromlen);
		FD_SET(sockList[lastSock-1], &readfdsCopy);
		nRetconec++;        //se incrementan las variables para contar el nmero de conexiones
		ntotconec++;

                /* En este punto se debe crear un nuevo socket para conexin con Proxy */
		pd = socket (AF_INET,SOCK_STREAM,0);
		reusePort(pd);
		sockProxy[lastProxy++]= pd;
		FD_SET(sockProxy[lastProxy-1], &readfdsCopy);


		if (pd<0)
		{
			perror("abriendo socket stream");
  			exit(-1);
		}

		if ( connect(pd, (struct sockaddr *)&proxy, sizeof(proxy)) < 0 )
		{
 			close(pd);
   			perror("conectando socket stream");
     			exit(0);
 		}
	}

	cleanup(inbuf);    //limpiar buffer

	    /* Se chequea la entrada estndar. Si se ingres ENTER se imprimen los datos pedidos */
	    if (FD_ISSET(0, &readfds))

	       if(cc=read(0, inbuf, sizeof(inbuf))>0)
	       {
	          printf("Nmero bytes desde ltimo RETURN: %d \n", nRetbytes );
		  printf("Nmero de conexiones nuevas establecidas: %d \n", nRetconec );
		  printf("Nmero de bytes (desde el inicio): %d \n", ntotbytes);
		  printf("Nmero conexiones totales desde inicio: %d \n\n", ntotconec);
		  nRetbytes=0;
		  nRetconec=0;
		}

      for (i=0; i < lastSock; i++)
      {

        /*Revisar cada punto de conexin desde clientes que intentan obtener pginas Web.
	  Para cada socket se invoca a la funcin EchoServe, que se encarga de realizar
	  el traspaso de paquetes desde el cliente hacia el proxy para que este ltimo le
	  devuelva la pgina Web solicitada.  En este proceso se cuenta en nmero de bytes
	  de la pgina descargada, cumpliendo la funcin de pesador.  Como se utiliza
	  la misma funcin tanto de ida como de vuelta, y lo que interesa es pesar los paquetes
	  de vuelta, se recurre a un flag (tercer argumento de EchoServer), el cual es seteado a uno
	  para que esta ltima realice el conteo */

	if (FD_ISSET(sockList[i], &readfds))

	    if (EchoServe(sockList[i], sockProxy[i], 0) < 0)
	    {
	      FD_CLR(sockList[i], &readfdsCopy);
	      FD_CLR(sockProxy[i], &readfdsCopy);   //si se cierra una conexin se decrementa,
	      sockList[i] = sockList[--lastSock];   //tanto sockList como sockProxy
	      sockProxy[i]= sockProxy[--lastProxy];
	      i--;
	     }

	    /*Conexiones desde el proxy hacia el cliente */

	    if (FD_ISSET(sockProxy[i], &readfds))

	    if (EchoServe(sockProxy[i], sockList[i], 1) < 0)
	    {
	      FD_CLR(sockList[i], &readfdsCopy);
	      FD_CLR(sockProxy[i], &readfdsCopy);   //dem al anterior
	      sockList[i] = sockList[--lastSock];
	      sockProxy[i]= sockProxy[--lastProxy];
	      i--;

	    }
      }

    }
  }
}


/*esta rutina debe contactarse con el proxy, para recibir los paquetes
que ste enva al cliente, pesarlos, y reenviarlos al cliente. Se realiza
el traspaso de paquetes de un lado hacia el otro, y viceversa */

int EchoServe(int psd, int ppd, int flag)
{
  char buf[BUFSIZE];
  //char rbuf[BUFSIZE];
  //static int ntotbytes;
  int rc;

  for(;;)
  {

    if( (rc=read(psd, buf, sizeof(buf))) < 0)
      perror("receiving stream  message");


    if (rc > 0)
    {

      if( flag==1)              //flag==1 entonces proviene del proxy, hay que pesarlos
         {
	 nRetbytes += rc;
         ntotbytes += rc;
	 }

	if (send(ppd, buf, rc, 0) <0 )
	    perror("sending stream message");
      return(1);
    }

    else
    {
      //printf("Desconectado...\n");    se cierra una conexin
      close(psd);
      close(ppd);
      return(-1);
    }
  }
}


/***************** REUSAR PUERTO ***************************/
void reusePort(int s)
{
  int one=1;

  if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 )
  {
    printf("error in setsockopt,SO_REUSEPORT \n");
    exit(-1);
  }
}


/******************************** LIMPIAR BUFFER ***********************************/
cleanup(buf)
char *buf;
{
  int i;
  for(i=0; i<BUFSIZE; i++) buf[i]='\0';
}
